VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Trick hash table test"
   ClientHeight    =   2115
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   5940
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2115
   ScaleWidth      =   5940
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox cboCompareMode 
      Height          =   315
      ItemData        =   "frmMain.frx":0000
      Left            =   180
      List            =   "frmMain.frx":000A
      Style           =   2  'Dropdown List
      TabIndex        =   7
      Top             =   1125
      Width           =   5595
   End
   Begin VB.CommandButton cmdForEach 
      Caption         =   "For each"
      Height          =   480
      Left            =   4410
      TabIndex        =   5
      Top             =   150
      Width           =   1395
   End
   Begin VB.OptionButton optComponent 
      Caption         =   "Dictionary"
      Height          =   345
      Index           =   1
      Left            =   3090
      TabIndex        =   4
      Top             =   735
      Width           =   1875
   End
   Begin VB.OptionButton optComponent 
      Caption         =   "TrickHashTable"
      Height          =   345
      Index           =   0
      Left            =   1260
      TabIndex        =   3
      Top             =   735
      Value           =   -1  'True
      Width           =   1875
   End
   Begin VB.CommandButton cmdAccessAll 
      Caption         =   "Access all"
      Height          =   480
      Left            =   2985
      TabIndex        =   2
      Top             =   150
      Width           =   1395
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear"
      Height          =   480
      Left            =   1560
      TabIndex        =   1
      Top             =   150
      Width           =   1395
   End
   Begin VB.CommandButton cmdAdd100000 
      Caption         =   "Add 100000"
      Height          =   480
      Left            =   135
      TabIndex        =   0
      Top             =   165
      Width           =   1395
   End
   Begin VB.Label lblCount 
      ForeColor       =   &H8000000D&
      Height          =   330
      Left            =   90
      TabIndex        =   6
      Top             =   1635
      Width           =   5775
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' // Test of performance between clsTrickHashTable and Dictionary
' //  Krivous Anatolii Anatolevich (The trick), 2014
' // Special thanks to Dragokas for debugging.

Option Explicit

Private Declare Function QueryPerformanceFrequency Lib "kernel32" ( _
                         ByRef lpFrequency As Any) As Long
Private Declare Function QueryPerformanceCounter Lib "kernel32" ( _
                         ByRef lpPerformanceCount As Any) As Long

Dim hsh     As clsTrickHashTable
Dim dic     As Dictionary
Dim freq    As Currency
Dim tim1    As Currency
Dim tim2    As Currency

Private Sub cboCompareMode_Click()
    hsh.CompareMode = cboCompareMode.ListIndex
    dic.CompareMode = cboCompareMode.ListIndex
End Sub

Private Sub cmdAccessAll_Click()
    Dim Keys    As Variant
    Dim idx     As Long
    Dim out     As Long
    
    QueryPerformanceCounter tim1
    
    If optComponent(0) Then

        Keys = hsh.Keys()
        
        For idx = 0 To hsh.Count - 1
            out = out + Len(hsh.Item(Keys(idx)))
        Next
        
    Else
        
        Keys = dic.Keys()

        For idx = 0 To dic.Count - 1
            out = out + Len(dic.Item(Keys(idx)))
        Next
        
    End If
    
    QueryPerformanceCounter tim2
    
    MsgBox Format((tim2 - tim1) / freq, "##0.000s") & vbNewLine & out
    
End Sub

Private Sub cmdAdd100000_Click()
    Dim i As Long
    
    QueryPerformanceCounter tim1
    
    If optComponent(0) Then
    
        For i = hsh.Count To hsh.Count + 99999
            hsh.Add "Key" & i, "item" & i
        Next
    
    Else
    
        For i = dic.Count To dic.Count + 99999
            dic.Add "Key" & i, "item" & i
        Next
        
    End If

    QueryPerformanceCounter tim2
    
    MsgBox Format((tim2 - tim1) / freq, "##0.000s")
    
    UpdateInfo
End Sub

Private Sub cmdClear_Click()
    If optComponent(0) Then
    
        hsh.RemoveAll
    
    Else
    
        dic.RemoveAll
        
    End If
    
    UpdateInfo
    
End Sub

Private Sub cmdForEach_Click()
    Dim dat     As Variant
    Dim out     As Long
    
    QueryPerformanceCounter tim1
    
    If optComponent(0) Then

        For Each dat In hsh
            out = out + Len(dat)
        Next
        
    Else
        
        For Each dat In dic
            out = out + Len(dat)
        Next
        
    End If
    
    QueryPerformanceCounter tim2
    
    MsgBox Format((tim2 - tim1) / freq, "##0.000s") & vbNewLine & out
End Sub

Private Sub Form_Load()

    Set hsh = New clsTrickHashTable
    Set dic = New Dictionary
    QueryPerformanceFrequency freq
    UpdateInfo
    cboCompareMode.ListIndex = 0
    
End Sub

Private Sub UpdateInfo()
    lblCount.Caption = "Count: " & IIf(optComponent(0), hsh.Count, dic.Count)
    cboCompareMode.Enabled = (hsh.Count = 0 And dic.Count = 0)
End Sub

Private Sub optComponent_Click(Index As Integer)
    UpdateInfo
End Sub
